#ifndef DOMAIN_COMDELVALIDATOR_H
#define DOMAIN_COMDELVALIDATOR_H

#include "functionsignature.h"
#include "library.h"

#include <vector>

#include <comdel/parser/parsecontext.h>
#include <comdel/parser/sourceerror.h>

namespace domain {

class ComdelValidator
{
private:
    std::vector<SourceError> errors;
    std::vector<FunctionSignature> signatures;

public:

    ComdelValidator(std::vector<FunctionSignature> signatures);

    std::vector<SourceError> getErrors() {
        return errors;
    }

    void validateLibrary(Library library, ParseContext* parseContext, std::ostream& stream);

};

} // namespace domain

#endif // DOMAIN_COMDELVALIDATOR_H
