#ifndef DOMAIN_CONNECTION_H
#define DOMAIN_CONNECTION_H

#include "attribute.h"

#include <string>
#include <vector>

namespace domain {

class Connection
{
    std::string component;
    std::string pin;
    std::string bus;

    std::vector<Attribute> attributes;
    std::vector<Value> wires;
public:
    Connection(std::string component, std::string pin, std::string bus, std::vector<Attribute> attributes, std::vector<Value> wires);

    bool isConnecting(std::string component, std::string pin, std::string bus);

    std::string getComponent();
    std::string getPin();
    std::string getBus();

    std::vector<Attribute> getAttributes();
    std::vector<Value> getWires();

    Attribute getAttribute(std::string name);
    bool hasAttribute(std::string name);
};

} // namespace domain

#endif // DOMAIN_CONNECTION_H
